package com.framsticks.portals;

import com.framsticks.core.Path;
import com.framsticks.observers.Endpoint;
import com.framsticks.util.dispatching.Dispatching;
import com.framsticks.util.dispatching.Future;
import com.framsticks.util.Logging;
import org.apache.log4j.Logger;

/**
 * @author Piotr Sniegowski
 */
public class PortalEndpoint extends Endpoint {

	private final static Logger log = Logger.getLogger(PortalEndpoint.class.getName());

	public PortalEndpoint() {
	}

    @Override
    public Portal getObserver() {
        return (Portal) observer;
    }

    @Override
    public void onRun(Exception e) {
        assert Dispatching.isThreadSafe();

        super.onRun(e);

        if (e != null) {
            return;
        }
        final String path = "/simulator/genepools/groups/0/genotypes";
        instance.invokeLater(new Runnable() {
            @Override
            public void run() {
                PortalEndpoint.this.instance.resolve(path, new Future<Path>() {
                    @Override
                    public void result(Path result, Exception e) {
                        Logging.log(log, "resolve", path, e);
                    }
                });
            }
        });
    }

    @Override
    public void onStop(Exception e) {
    }


    /*@Override
    public void onChange(final Path path) {
        //if path.getTop().getParam().
        observer.invokeLater(new Runnable() {
            @Override
            public void run() {
                log.debug("change at " + path);
            }
        });
    }
    */




}
